> For the complete documentation index, see [llms.txt](https://andrecronje.gitbook.io/yearn-finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://andrecronje.gitbook.io/yearn-finance/developers/misc-resources/smart-contract-integration/uniswapapr.md).

# uniswapapr

| Contract   | ABI                                                                                              | Address                                                                                                  |
| ---------- | ------------------------------------------------------------------------------------------------ | -------------------------------------------------------------------------------------------------------- |
| UniswapAPR | [JSON](https://github.com/iearn-finance/uniswap-roi/blob/master/build/contracts/UniswapAPR.json) | [uniapr.iearn.eth](https://etherscan.io/address/0x4c70D89A4681b2151F56Dc2c3FD751aBb9CE3D95#readContract) |

## UniswapAPR Interface

{% tabs %}
{% tab title="IUniswapAPR.sol" %}

```javascript
// Solidity Interface

contract IUniswapAPR {

    function getBlocksPerYear() external view returns (uint256);

    function calcUniswapAPRADAI() external view returns (uint256, uint256);
    function calcUniswapAPRCDAI() external view returns (uint256, uint256);
    function calcUniswapAPRCETH() external view returns (uint256, uint256);
    function calcUniswapAPRCSAI() external view returns (uint256, uint256);
    function calcUniswapAPRCUSDC() external view returns (uint256, uint256);
    function calcUniswapAPRDAI() external view returns (uint256, uint256);
    function calcUniswapAPRIDAI() external view returns (uint256, uint256);
    function calcUniswapAPRISAI() external view returns (uint256, uint256);
    function calcUniswapAPRSUSD() external view returns (uint256, uint256);
    function calcUniswapAPRTUSD() external view returns (uint256, uint256);
    function calcUniswapAPRUSDC() external view returns (uint256, uint256);
    function calcUniswapAPRCHAI() external view returns (uint256, uint256);

    function calcUniswapAPRFromROI(uint256 roi, uint256 createdAt) external view returns (uint256);

    function calcUniswapAPR(address token, uint256 createdAt) external view returns (uint256);
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://andrecronje.gitbook.io/yearn-finance/developers/misc-resources/smart-contract-integration/uniswapapr.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
